org.apache.xerces.xni

## Interface XMLAttributes

-     public interface XMLAttributes

  The XMLAttributes interface defines a collection of attributes for an element. In the parser, the document source would scan the entire start element and collect the attributes. The attributes are communicated to the document handler in the startElement method.

  The attributes are read-write so that subsequent stages in the document pipeline can modify the values or change the attributes that are propagated to the next stage.

  Version:
    $Id: XMLAttributes.java 570130 2007-08-27 14:10:55Z mrglavas $
  Author:
    Andy Clark, IBM
  See Also:
    `XMLDocumentHandler.startElement(org.apache.xerces.xni.QName, org.apache.xerces.xni.XMLAttributes, org.apache.xerces.xni.Augmentations)`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `addAttribute(QName attrName, java.lang.String attrType, java.lang.String attrValue)` Adds an attribute.
    `Augmentations` | `getAugmentations(int attributeIndex)` Look up an augmentation by attribute's index.
    `Augmentations` | `getAugmentations(java.lang.String qName)` Look up an augmentation by XML 1.0 qualified name.
    `Augmentations` | `getAugmentations(java.lang.String uri, java.lang.String localPart)` Look up an augmentation by namespace name.
    `int` | `getIndex(java.lang.String qName)` Look up the index of an attribute by XML 1.0 qualified name.
    `int` | `getIndex(java.lang.String uri, java.lang.String localPart)` Look up the index of an attribute by Namespace name.
    `int` | `getLength()` Returns the number of attributes in the list.
    `java.lang.String` | `getLocalName(int index)` Look up an attribute's local name by index.
    `void` | `getName(int attrIndex, QName attrName)` Sets the fields in the given QName structure with the values of the attribute name at the specified index.
    `java.lang.String` | `getNonNormalizedValue(int attrIndex)` Returns the non-normalized value of the attribute at the specified index.
    `java.lang.String` | `getPrefix(int index)` Returns the prefix of the attribute at the specified index.
    `java.lang.String` | `getQName(int index)` Look up an attribute's XML 1.0 qualified name by index.
    `java.lang.String` | `getType(int index)` Look up an attribute's type by index.
    `java.lang.String` | `getType(java.lang.String qName)` Look up an attribute's type by XML 1.0 qualified name.
    `java.lang.String` | `getType(java.lang.String uri, java.lang.String localName)` Look up an attribute's type by Namespace name.
    `java.lang.String` | `getURI(int index)` Look up an attribute's Namespace URI by index.
    `java.lang.String` | `getValue(int index)` Look up an attribute's value by index.
    `java.lang.String` | `getValue(java.lang.String qName)` Look up an attribute's value by XML 1.0 qualified name.
    `java.lang.String` | `getValue(java.lang.String uri, java.lang.String localName)` Look up an attribute's value by Namespace name.
    `boolean` | `isSpecified(int attrIndex)` Returns true if the attribute is specified in the instance document.
    `void` | `removeAllAttributes()` Removes all of the attributes.
    `void` | `removeAttributeAt(int attrIndex)` Removes the attribute at the specified index.
    `void` | `setAugmentations(int attrIndex, Augmentations augs)` Sets the augmentations of the attribute at the specified index.
    `void` | `setName(int attrIndex, QName attrName)` Sets the name of the attribute at the specified index.
    `void` | `setNonNormalizedValue(int attrIndex, java.lang.String attrValue)` Sets the non-normalized value of the attribute at the specified index.
    `void` | `setSpecified(int attrIndex, boolean specified)` Sets whether an attribute is specified in the instance document or not.
    `void` | `setType(int attrIndex, java.lang.String attrType)` Sets the type of the attribute at the specified index.
    `void` | `setValue(int attrIndex, java.lang.String attrValue)` Sets the value of the attribute at the specified index.

- - ### Method Detail

    - #### addAttribute

          int addAttribute(QName attrName,
                         java.lang.String attrType,
                         java.lang.String attrValue)

      Adds an attribute. The attribute's non-normalized value of the attribute will have the same value as the attribute value until set using the `setNonNormalizedValue` method. Also, the added attribute will be marked as specified in the XML instance document unless set otherwise using the `setSpecified` method.

      Note: If an attribute of the same name already exists, the old values for the attribute are replaced by the new values.

      Parameters:
        `attrName` - The attribute name.
        `attrType` - The attribute type. The type name is determined by the type specified for this attribute in the DTD. For example: "CDATA", "ID", "NMTOKEN", etc. However, attributes of type enumeration will have the type value specified as the pipe ('|') separated list of the enumeration values prefixed by an open parenthesis and suffixed by a close parenthesis. For example: "(true|false)".
        `attrValue` - The attribute value.
      Returns:
        Returns the attribute index.
      See Also:
        `setNonNormalizedValue(int, java.lang.String)`, `setSpecified(int, boolean)`

    - #### removeAllAttributes

          void removeAllAttributes()

      Removes all of the attributes. This method will also remove all entities associated to the attributes.

    - #### removeAttributeAt

          void removeAttributeAt(int attrIndex)

      Removes the attribute at the specified index.

      Note: This operation changes the indexes of all attributes following the attribute at the specified index.

      Parameters:
        `attrIndex` - The attribute index.

    - #### getLength

          int getLength()

      Returns the number of attributes in the list.

      Once you know the number of attributes, you can iterate through the list.

      See Also:
        `getURI(int)`, `getLocalName(int)`, `getQName(int)`, `getType(int)`, `getValue(int)`

    - #### getIndex

          int getIndex(java.lang.String qName)

      Look up the index of an attribute by XML 1.0 qualified name.
      Parameters:
        `qName` - The qualified (prefixed) name.
      Returns:
        The index of the attribute, or -1 if it does not appear in the list.

    - #### getIndex

          int getIndex(java.lang.String uri,
                     java.lang.String localPart)

      Look up the index of an attribute by Namespace name.
      Parameters:
        `uri` - The Namespace URI, or the empty string if the name has no Namespace URI.
        `localPart` - The attribute's local name.
      Returns:
        The index of the attribute, or -1 if it does not appear in the list.

    - #### setName

          void setName(int attrIndex,
                     QName attrName)

      Sets the name of the attribute at the specified index.
      Parameters:
        `attrIndex` - The attribute index.
        `attrName` - The new attribute name.

    - #### getName

          void getName(int attrIndex,
                     QName attrName)

      Sets the fields in the given QName structure with the values of the attribute name at the specified index.
      Parameters:
        `attrIndex` - The attribute index.
        `attrName` - The attribute name structure to fill in.

    - #### getPrefix

          java.lang.String getPrefix(int index)

      Returns the prefix of the attribute at the specified index.
      Parameters:
        `index` - The index of the attribute.

    - #### getURI

          java.lang.String getURI(int index)

      Look up an attribute's Namespace URI by index.
      Parameters:
        `index` - The attribute index (zero-based).
      Returns:
        The Namespace URI, or the empty string if none is available, or null if the index is out of range.
      See Also:
        `getLength()`

    - #### getLocalName

          java.lang.String getLocalName(int index)

      Look up an attribute's local name by index.
      Parameters:
        `index` - The attribute index (zero-based).
      Returns:
        The local name, or the empty string if Namespace processing is not being performed, or null if the index is out of range.
      See Also:
        `getLength()`

    - #### getQName

          java.lang.String getQName(int index)

      Look up an attribute's XML 1.0 qualified name by index.
      Parameters:
        `index` - The attribute index (zero-based).
      Returns:
        The XML 1.0 qualified name, or the empty string if none is available, or null if the index is out of range.
      See Also:
        `getLength()`

    - #### setType

          void setType(int attrIndex,
                     java.lang.String attrType)

      Sets the type of the attribute at the specified index.
      Parameters:
        `attrIndex` - The attribute index.
        `attrType` - The attribute type. The type name is determined by the type specified for this attribute in the DTD. For example: "CDATA", "ID", "NMTOKEN", etc. However, attributes of type enumeration will have the type value specified as the pipe ('|') separated list of the enumeration values prefixed by an open parenthesis and suffixed by a close parenthesis. For example: "(true|false)".

    - #### getType

          java.lang.String getType(int index)

      Look up an attribute's type by index.

      The attribute type is one of the strings "CDATA", "ID", "IDREF", "IDREFS", "NMTOKEN", "NMTOKENS", "ENTITY", "ENTITIES", or "NOTATION" (always in upper case).

      If the parser has not read a declaration for the attribute, or if the parser does not report attribute types, then it must return the value "CDATA" as stated in the XML 1.0 Recommendation (clause 3.3.3, "Attribute-Value Normalization").

      For an enumerated attribute that is not a notation, the parser will report the type as "NMTOKEN".

      Parameters:
        `index` - The attribute index (zero-based).
      Returns:
        The attribute's type as a string, or null if the index is out of range.
      See Also:
        `getLength()`

    - #### getType

          java.lang.String getType(java.lang.String qName)

      Look up an attribute's type by XML 1.0 qualified name.

      See `getType(int)` for a description of the possible types.

      Parameters:
        `qName` - The XML 1.0 qualified name.
      Returns:
        The attribute type as a string, or null if the attribute is not in the list or if qualified names are not available.

    - #### getType

          java.lang.String getType(java.lang.String uri,
                                 java.lang.String localName)

      Look up an attribute's type by Namespace name.

      See `getType(int)` for a description of the possible types.

      Parameters:
        `uri` - The Namespace URI, or the empty String if the name has no Namespace URI.
        `localName` - The local name of the attribute.
      Returns:
        The attribute type as a string, or null if the attribute is not in the list or if Namespace processing is not being performed.

    - #### setValue

          void setValue(int attrIndex,
                      java.lang.String attrValue)

      Sets the value of the attribute at the specified index. This method will overwrite the non-normalized value of the attribute.
      Parameters:
        `attrIndex` - The attribute index.
        `attrValue` - The new attribute value.
      See Also:
        `setNonNormalizedValue(int, java.lang.String)`

    - #### getValue

          java.lang.String getValue(int index)

      Look up an attribute's value by index.

      If the attribute value is a list of tokens (IDREFS, ENTITIES, or NMTOKENS), the tokens will be concatenated into a single string with each token separated by a single space.

      Parameters:
        `index` - The attribute index (zero-based).
      Returns:
        The attribute's value as a string, or null if the index is out of range.
      See Also:
        `getLength()`

    - #### getValue

          java.lang.String getValue(java.lang.String qName)

      Look up an attribute's value by XML 1.0 qualified name.

      See `getValue(int)` for a description of the possible values.

      Parameters:
        `qName` - The XML 1.0 qualified name.
      Returns:
        The attribute value as a string, or null if the attribute is not in the list or if qualified names are not available.

    - #### getValue

          java.lang.String getValue(java.lang.String uri,
                                  java.lang.String localName)

      Look up an attribute's value by Namespace name.

      See `getValue(int)` for a description of the possible values.

      Parameters:
        `uri` - The Namespace URI, or the empty String if the name has no Namespace URI.
        `localName` - The local name of the attribute.
      Returns:
        The attribute value as a string, or null if the attribute is not in the list.

    - #### setNonNormalizedValue

          void setNonNormalizedValue(int attrIndex,
                                   java.lang.String attrValue)

      Sets the non-normalized value of the attribute at the specified index.
      Parameters:
        `attrIndex` - The attribute index.
        `attrValue` - The new non-normalized attribute value.

    - #### getNonNormalizedValue

          java.lang.String getNonNormalizedValue(int attrIndex)

      Returns the non-normalized value of the attribute at the specified index. If no non-normalized value is set, this method will return the same value as the `getValue(int)` method.
      Parameters:
        `attrIndex` - The attribute index.

    - #### setSpecified

          void setSpecified(int attrIndex,
                          boolean specified)

      Sets whether an attribute is specified in the instance document or not.
      Parameters:
        `attrIndex` - The attribute index.
        `specified` - True if the attribute is specified in the instance document.

    - #### isSpecified

          boolean isSpecified(int attrIndex)

      Returns true if the attribute is specified in the instance document.
      Parameters:
        `attrIndex` - The attribute index.

    - #### getAugmentations

          Augmentations getAugmentations(int attributeIndex)

      Look up an augmentation by attribute's index.
      Parameters:
        `attributeIndex` - The attribute index.
      Returns:
        Augmentations

    - #### getAugmentations

          Augmentations getAugmentations(java.lang.String uri,
                                       java.lang.String localPart)

      Look up an augmentation by namespace name.
      Parameters:
        `uri` - The Namespace URI, or the empty string if the name has no Namespace URI.
        `localPart` -
      Returns:
        Augmentations

    - #### getAugmentations

          Augmentations getAugmentations(java.lang.String qName)

      Look up an augmentation by XML 1.0 qualified name.

      Parameters:
        `qName` - The XML 1.0 qualified name.
      Returns:
        Augmentations

    - #### setAugmentations

          void setAugmentations(int attrIndex,
                              Augmentations augs)

      Sets the augmentations of the attribute at the specified index.
      Parameters:
        `attrIndex` - The attribute index.
        `augs` - The augmentations.

Copyright © 1999-2022 The Apache Software Foundation. All Rights Reserved.